package com.school.project.controller;


import com.school.project.dto.course.CourseRegisterDTO;
import com.school.project.service.course.CourseServiceImp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.server.ResponseStatusException;

@RestController
@RequestMapping("/course")
public class CourseController {
    @Autowired
    private CourseServiceImp courseServiceImp;

    @PostMapping("/save")
    private ResponseEntity saveCourse(@RequestBody CourseRegisterDTO course) {
        try {
            courseServiceImp.saveCourse(course);
            return ResponseEntity.ok("Course Saved");
        } catch (Exception e) {
            throw new ResponseStatusException(HttpStatus.BAD_REQUEST, "Data Is Not Correct", e);
        }
    }


}
