package com.school.project.controller;


import com.school.project.dto.student.StudentCourseRegistrationDTO;
import com.school.project.dto.student.StudentCoursesDTO;
import com.school.project.dto.student.StudentViewDataDTO;
import com.school.project.service.courseRegistration.CourseRegistrationService;
import com.school.project.service.student.StudentServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.annotation.CurrentSecurityContext;
import org.springframework.web.bind.annotation.*;

import java.security.Principal;
import java.util.List;
import java.util.Set;

@RestController
@RequestMapping("/student")
public class StudentController {

    @Autowired
    private StudentServiceImpl studentService;

    @Autowired
    private CourseRegistrationService courseRegistrationService;

    @GetMapping("")
    public StudentViewDataDTO getUserDetails(@CurrentSecurityContext(expression = "authentication") Authentication authentication) {

        return studentService.viewData(authentication.getName());

    }

    @GetMapping("/course")
    public StudentCoursesDTO showCourses(Principal principal) {

        return studentService.viewCourses(studentService.getUserId(principal.getName()));
    }

    @PostMapping("/course/register")
    public void registerCourses(Principal principal, @RequestBody Set<StudentCourseRegistrationDTO> courses) {

        courseRegistrationService.courseRegistration(studentService.getUserId(principal.getName()), courses);
    }
}
